function [out,pr]=percentiledp(X,dp);
% [out]=percentiledp(X);
% dp (npx1): columnvector containing np desired percentiles OR matrix containing np desired percentiles per column of X
% X (nxj): inputmatrix
% out (npxj): desired percentiles per column of X
%pr: proportion of cases at 0 or n (borders)




[n,j]=size(X);
vv=sort(X);

ndp=dp*n+0.5;
ndpf=floor(ndp)   ;
ndpc=ceil(ndp);

x=double(ndpf==0);
pr=mean(x);

ndp=ndp+0.50001*x;
ndpf=ndpf+x;
ndpc=ndpc+x;


x=double(ndpc>n);
pr=(pr+mean(x))';
ndp=ndp-0.50001*x;
ndpf=ndpf-x;
ndpc=ndpc-x;




if size(dp,2)==1,
vv1=vv(ndpf,:);	
vv2=vv(ndpc,:);	

out= ((ndp-ndpf)*ones(1,j).*vv2)+  ((1+(ndpf-ndp)*ones(1,j)).*vv1);

else

    for ii=1:j,
    vv1(:,ii)=vv(ndpf(:,ii),ii);	
    vv2(:,ii)=vv(ndpc(:,ii),ii);	
    end

 out= ((ndp-ndpf).*vv2)+  ((1+(ndpf-ndp)).*vv1);
end


